#!/usr/bin/perl -w
## ######### PROJECT NAME : ##########
## 
## bench.pm for benchmark librairie in /var/www/perl/benchmark/script
## 
## ######### PROJECT DESCRIPTION : ###
## 
## 
## 
## ###################################
## 
## Made by husianycia cedric
## Login   <root@intellique.com>
## 
## Started on  Mon Apr  3 14:39:06 2006 husianycia cedric
## Last update Wed Apr  5 12:26:22 2006 husianycia cedric
## 
## ###################################
##

## ###################################
## Declaration de librairies

use	strict;

## ###################################
## Declaration de package

package	bench;

## ###################################
## Declaration de variables

my $path_file	= "";

## ###################################
## Methode de retour d'erreur Fatale

sub	fatal {
    my $msg = shift;
    
    print "FATAL ERROR :\n\t".$msg."\n";

    exit 1;
}

## ###################################
## Methode de lecture du fichier de bench
## Retourne la hash de perf

sub	read_info {
    $path_file = shift;

    open (FD, $path_file) or fatal("Erreur sur $path_file : $!");
    
    my @tab = <FD>;
    close (FD);
    @tab = reverse @tab;
    
    my @result = split(",", $tab[0]);

    my %hash;

    $hash{'hostname'} = $result[0];
    $hash{'chunk size'} = $result[1];
    $hash{'write'} = $result[4] / 1000;
    $hash{'writeCPU'} = $result[5];
    $hash{'rewrite'} = $result[6] / 1000;
    $hash{'rewriteCPU'} = $result[7];
    $hash{'read'} = $result[10] / 1000;
    $hash{'readCPU'} = $result[11];
    
    return %hash;
}

## ###################################
## Excution de bonnie++

sub	start {
    $path_file	= shift;
    my $dir	= shift;
    
    print "Starting test ...\n";
    
    if (-d $dir){
	qx#bonnie++ -f -u root -d $dir > $path_file#;
    }
    else {
      fatal("$dir doesn't exist.");
    }
    print "...Ending\n";
}


## ###################################
## Fin du package

1;

